#### import the simple module from the paraview
from paraview.simple import *
#### disable automatic camera reset on 'Show'
paraview.simple._DisableFirstRenderCameraReset()

# create a new 'PVFoamReader'
#aOpenFOAM = PVFoamReader(FileName='/home/user/cavity/cavity/a.OpenFOAM')
#aOpenFOAM = PVFoamReader(FileName='a.OpenFOAM')
#aOpenFOAM.UiRefresh = 0
#aOpenFOAM.UseVTKPolyhedron = 0
#aOpenFOAM.MeshParts = ['internalMesh']
#aOpenFOAM.VolumeFields = ['p', 'U']
#aOpenFOAM.LagrangianFields = []
#aOpenFOAM.PointFields = []
aOpenFOAM = OpenFOAMReader(FileName='a.OpenFOAM')
aOpenFOAM.CaseType = 'Reconstructed Case'
aOpenFOAM.Createcelltopointfiltereddata = 1
aOpenFOAM.Adddimensionalunitstoarraynames = 0
aOpenFOAM.MeshRegions = ['internalMesh']
aOpenFOAM.CellArrays = ['U', 'p']
aOpenFOAM.PointArrays = []
aOpenFOAM.LagrangianArrays = []
aOpenFOAM.Cachemesh = 1
aOpenFOAM.Decomposepolyhedra = 1
aOpenFOAM.ListtimestepsaccordingtocontrolDict = 0
aOpenFOAM.LagrangianpositionsareinOF13binaryformat = 0
aOpenFOAM.Readzones = 0


# get animation scene
animationScene1 = GetAnimationScene()

# update animation scene based on data timesteps
animationScene1.UpdateAnimationUsingDataTimeSteps()

# get active view
renderView1 = GetActiveViewOrCreate('RenderView')
# uncomment following to set a specific view size
renderView1.ViewSize = [1071, 674]

#mod
# Properties modified on renderView1
renderView1.OrientationAxesVisibility = 0

# show data in view
aOpenFOAMDisplay = Show(aOpenFOAM, renderView1)
# trace defaults for the display properties.
aOpenFOAMDisplay.CubeAxesVisibility = 0
aOpenFOAMDisplay.Representation = 'Surface'
aOpenFOAMDisplay.AmbientColor = [1.0, 1.0, 1.0]
aOpenFOAMDisplay.ColorArrayName = [None, '']
aOpenFOAMDisplay.DiffuseColor = [1.0, 1.0, 1.0]
aOpenFOAMDisplay.LookupTable = None
aOpenFOAMDisplay.MapScalars = 1
aOpenFOAMDisplay.InterpolateScalarsBeforeMapping = 1
aOpenFOAMDisplay.Opacity = 1.0
aOpenFOAMDisplay.PointSize = 2.0
aOpenFOAMDisplay.LineWidth = 1.0
aOpenFOAMDisplay.Interpolation = 'Gouraud'
aOpenFOAMDisplay.Specular = 0.0
aOpenFOAMDisplay.SpecularColor = [1.0, 1.0, 1.0]
aOpenFOAMDisplay.SpecularPower = 100.0
aOpenFOAMDisplay.Ambient = 0.0
aOpenFOAMDisplay.Diffuse = 1.0
aOpenFOAMDisplay.EdgeColor = [0.0, 0.0, 0.5]
aOpenFOAMDisplay.BackfaceRepresentation = 'Follow Frontface'
aOpenFOAMDisplay.BackfaceAmbientColor = [1.0, 1.0, 1.0]
aOpenFOAMDisplay.BackfaceDiffuseColor = [1.0, 1.0, 1.0]
aOpenFOAMDisplay.BackfaceOpacity = 1.0
aOpenFOAMDisplay.Position = [0.0, 0.0, 0.0]
aOpenFOAMDisplay.Scale = [1.0, 1.0, 1.0]
aOpenFOAMDisplay.Orientation = [0.0, 0.0, 0.0]
aOpenFOAMDisplay.Origin = [0.0, 0.0, 0.0]
aOpenFOAMDisplay.Pickable = 1
aOpenFOAMDisplay.Texture = None
aOpenFOAMDisplay.Triangulate = 0
aOpenFOAMDisplay.NonlinearSubdivisionLevel = 1
aOpenFOAMDisplay.GlyphType = 'Arrow'
aOpenFOAMDisplay.CubeAxesColor = [1.0, 1.0, 1.0]
aOpenFOAMDisplay.CubeAxesCornerOffset = 0.0
aOpenFOAMDisplay.CubeAxesFlyMode = 'Closest Triad'
aOpenFOAMDisplay.CubeAxesInertia = 1
aOpenFOAMDisplay.CubeAxesTickLocation = 'Inside'
aOpenFOAMDisplay.CubeAxesXAxisMinorTickVisibility = 1
aOpenFOAMDisplay.CubeAxesXAxisTickVisibility = 1
aOpenFOAMDisplay.CubeAxesXAxisVisibility = 1
aOpenFOAMDisplay.CubeAxesXGridLines = 0
aOpenFOAMDisplay.CubeAxesXTitle = 'X-Axis'
aOpenFOAMDisplay.CubeAxesUseDefaultXTitle = 1
aOpenFOAMDisplay.CubeAxesYAxisMinorTickVisibility = 1
aOpenFOAMDisplay.CubeAxesYAxisTickVisibility = 1
aOpenFOAMDisplay.CubeAxesYAxisVisibility = 1
aOpenFOAMDisplay.CubeAxesYGridLines = 0
aOpenFOAMDisplay.CubeAxesYTitle = 'Y-Axis'
aOpenFOAMDisplay.CubeAxesUseDefaultYTitle = 1
aOpenFOAMDisplay.CubeAxesZAxisMinorTickVisibility = 1
aOpenFOAMDisplay.CubeAxesZAxisTickVisibility = 1
aOpenFOAMDisplay.CubeAxesZAxisVisibility = 1
aOpenFOAMDisplay.CubeAxesZGridLines = 0
aOpenFOAMDisplay.CubeAxesZTitle = 'Z-Axis'
aOpenFOAMDisplay.CubeAxesUseDefaultZTitle = 1
aOpenFOAMDisplay.CubeAxesGridLineLocation = 'All Faces'
aOpenFOAMDisplay.CustomBounds = [0.0, 1.0, 0.0, 1.0, 0.0, 1.0]
aOpenFOAMDisplay.CustomBoundsActive = [0, 0, 0]
aOpenFOAMDisplay.OriginalBoundsRangeActive = [0, 0, 0]
aOpenFOAMDisplay.CustomRange = [0.0, 1.0, 0.0, 1.0, 0.0, 1.0]
aOpenFOAMDisplay.CustomRangeActive = [0, 0, 0]
aOpenFOAMDisplay.UseAxesOrigin = 0
aOpenFOAMDisplay.AxesOrigin = [0.0, 0.0, 0.0]
aOpenFOAMDisplay.CubeAxesXLabelFormat = '%-#6.3g'
aOpenFOAMDisplay.CubeAxesYLabelFormat = '%-#6.3g'
aOpenFOAMDisplay.CubeAxesZLabelFormat = '%-#6.3g'
aOpenFOAMDisplay.StickyAxes = 0
aOpenFOAMDisplay.CenterStickyAxes = 0
aOpenFOAMDisplay.SelectionCellLabelBold = 0
aOpenFOAMDisplay.SelectionCellLabelColor = [0.0, 1.0, 0.0]
aOpenFOAMDisplay.SelectionCellLabelFontFamily = 'Arial'
aOpenFOAMDisplay.SelectionCellLabelFontSize = 18
aOpenFOAMDisplay.SelectionCellLabelItalic = 0
aOpenFOAMDisplay.SelectionCellLabelJustification = 'Left'
aOpenFOAMDisplay.SelectionCellLabelOpacity = 1.0
aOpenFOAMDisplay.SelectionCellLabelShadow = 0
aOpenFOAMDisplay.SelectionPointLabelBold = 0
aOpenFOAMDisplay.SelectionPointLabelColor = [1.0, 1.0, 0.0]
aOpenFOAMDisplay.SelectionPointLabelFontFamily = 'Arial'
aOpenFOAMDisplay.SelectionPointLabelFontSize = 18
aOpenFOAMDisplay.SelectionPointLabelItalic = 0
aOpenFOAMDisplay.SelectionPointLabelJustification = 'Left'
aOpenFOAMDisplay.SelectionPointLabelOpacity = 1.0
aOpenFOAMDisplay.SelectionPointLabelShadow = 0
aOpenFOAMDisplay.ScalarOpacityUnitDistance = 0.01924175606617764
aOpenFOAMDisplay.SelectMapper = 'Projected tetra'

# init the 'Arrow' selected for 'GlyphType'
aOpenFOAMDisplay.GlyphType.TipResolution = 6
aOpenFOAMDisplay.GlyphType.TipRadius = 0.1
aOpenFOAMDisplay.GlyphType.TipLength = 0.35
aOpenFOAMDisplay.GlyphType.ShaftResolution = 6
aOpenFOAMDisplay.GlyphType.ShaftRadius = 0.03
aOpenFOAMDisplay.GlyphType.Invert = 0

# reset view to fit data
renderView1.ResetCamera()


animationScene1.GoToLast()

# set scalar coloring
ColorBy(aOpenFOAMDisplay, ('POINTS', 'p'))

# rescale color and/or opacity maps used to include current data range
aOpenFOAMDisplay.RescaleTransferFunctionToDataRange(True)

# show color bar/color legend
aOpenFOAMDisplay.SetScalarBarVisibility(renderView1, True)

# get color transfer function/color map for 'p'
pLUT = GetColorTransferFunction('p')
pLUT.LockDataRange = 0
pLUT.InterpretValuesAsCategories = 0
pLUT.ShowCategoricalColorsinDataRangeOnly = 0
pLUT.RescaleOnVisibilityChange = 0
pLUT.EnableOpacityMapping = 0
pLUT.RGBPoints = [-4.366660118103027, 0.231373, 0.298039, 0.752941, 0.24093985557556152, 0.865003, 0.865003, 0.865003, 4.84853982925415, 0.705882, 0.0156863, 0.14902]
pLUT.UseLogScale = 0
pLUT.ColorSpace = 'Diverging'
pLUT.UseBelowRangeColor = 0
pLUT.BelowRangeColor = [0.0, 0.0, 0.0]
pLUT.UseAboveRangeColor = 0
pLUT.AboveRangeColor = [1.0, 1.0, 1.0]
pLUT.NanColor = [1.0, 1.0, 0.0]
pLUT.Discretize = 1
pLUT.NumberOfTableValues = 256
pLUT.ScalarRangeInitialized = 1.0
pLUT.HSVWrap = 0
pLUT.VectorComponent = 0
pLUT.VectorMode = 'Magnitude'
pLUT.AllowDuplicateScalars = 1
pLUT.Annotations = []
pLUT.ActiveAnnotatedValues = []
pLUT.IndexedColors = []

# get opacity transfer function/opacity map for 'p'
pPWF = GetOpacityTransferFunction('p')
pPWF.Points = [-4.366660118103027, 0.0, 0.5, 0.0, 4.84853982925415, 1.0, 0.5, 0.0]
pPWF.AllowDuplicateScalars = 1
pPWF.ScalarRangeInitialized = 1

# get color legend/bar for pLUT in view renderView1
pLUTColorBar = GetScalarBar(pLUT, renderView1)
#mod
#pLUTColorBar.Position = [0.85, 0.05]
#pLUTColorBar.Position2 = [0.12, 0.43]
#pLUTColorBar.Position = [0.44, -0.13]
#pLUTColorBar.Position2 = [0.12, 0.43]
pLUTColorBar.AutoOrient = 1
pLUTColorBar.Orientation = 'Vertical'
pLUTColorBar.Title = 'p'
pLUTColorBar.ComponentTitle = ''
pLUTColorBar.TitleJustification = 'Centered'
pLUTColorBar.TitleColor = [1.0, 1.0, 1.0]
pLUTColorBar.TitleOpacity = 1.0
pLUTColorBar.TitleFontFamily = 'Arial'
pLUTColorBar.TitleBold = 0
pLUTColorBar.TitleItalic = 0
pLUTColorBar.TitleShadow = 0
pLUTColorBar.TitleFontSize = 7
pLUTColorBar.LabelColor = [1.0, 1.0, 1.0]
pLUTColorBar.LabelOpacity = 1.0
pLUTColorBar.LabelFontFamily = 'Arial'
pLUTColorBar.LabelBold = 0
pLUTColorBar.LabelItalic = 0
pLUTColorBar.LabelShadow = 0
pLUTColorBar.LabelFontSize = 7
pLUTColorBar.AutomaticLabelFormat = 1
pLUTColorBar.LabelFormat = '%-#6.3g'
pLUTColorBar.NumberOfLabels = 5
pLUTColorBar.DrawTickMarks = 1
pLUTColorBar.DrawSubTickMarks = 1
pLUTColorBar.DrawTickLabels = 1
pLUTColorBar.AddRangeLabels = 1
pLUTColorBar.RangeLabelFormat = '%4.3e'
pLUTColorBar.DrawAnnotations = 1
pLUTColorBar.AddRangeAnnotations = 0
pLUTColorBar.AutomaticAnnotations = 0
pLUTColorBar.DrawNanAnnotation = 0
pLUTColorBar.NanAnnotation = 'NaN'
pLUTColorBar.TextPosition = 'Ticks right/top, annotations left/bottom'
pLUTColorBar.AspectRatio = 20.0

# Properties modified on pLUTColorBar
pLUTColorBar.AutoOrient = 0
pLUTColorBar.Orientation = 'Horizontal'
#mod
pLUTColorBar.Position = [0.286, 0.015]
pLUTColorBar.Position2 = [0.43, 0.12]
pLUTColorBar.Title = 'Pressure,p (Pa)'
pLUTColorBar.TitleColor = [0.0, 0.0, 0.0]
pLUTColorBar.TitleFontFamily = 'Times'
pLUTColorBar.LabelColor = [0.0, 0.0, 0.0]
pLUTColorBar.LabelFontFamily = 'Times'
pLUTColorBar.AutomaticLabelFormat = 0
pLUTColorBar.LabelFormat = '%-#4.2g'
pLUTColorBar.RangeLabelFormat = '%4.2f'

# Apply a preset using its name. Note this may not work as expected when presets have duplicate names.
pLUT.ApplyPreset('Blue to Red Rainbow', True)

# Rescale transfer function
pLUT.RescaleTransferFunction(-4.4, 4.88)

# Rescale transfer function
pPWF.RescaleTransferFunction(-4.4, 4.88)

# Properties modified on renderView1
renderView1.Background = [1.0, 1.0, 1.0]

# current camera placement for renderView1
renderView1.CameraPosition = [0.05000000074505806, 0.05000000074505806, 0.27888724573938806]
renderView1.CameraFocalPoint = [0.05000000074505806, 0.05000000074505806, 0.004999999888241291]
renderView1.CameraParallelScale = 0.07088723543695315

# save screenshot
#SaveScreenshot('/home/user/cavity/cavity/test2.png', magnification=1, quality=100, view=renderView1)
SaveScreenshot('test2.png', magnification=1, quality=100, view=renderView1)

#### saving camera placements for all active views

# current camera placement for renderView1
renderView1.CameraPosition = [0.05000000074505806, 0.05000000074505806, 0.27888724573938806]
renderView1.CameraFocalPoint = [0.05000000074505806, 0.05000000074505806, 0.004999999888241291]
renderView1.CameraParallelScale = 0.07088723543695315

#### uncomment the following to render all views
# RenderAllViews()
# alternatively, if you want to write images, you can use SaveScreenshot(...).
